<!-- markdownlint-disable MD013 MD033 MD041 -->

<!-- header-logo-start -->
<div align="center">
  <a href="https://megalinter.github.io" target="blank" title="Visit MegaLinter Web Site">
    <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/images/mega-linter-logo.png" alt="MegaLinter" height="300px">
  </a>
</div>
<!-- header-logo-end -->

# MegaLinter Runner

[![Version](https://img.shields.io/npm/v/mega-linter-runner.svg)](https://npmjs.org/package/mega-linter-runner)
[![Downloads/week](https://img.shields.io/npm/dw/mega-linter-runner.svg)](https://npmjs.org/package/mega-linter-runner)
[![Downloads/total](https://img.shields.io/npm/dt/mega-linter-runner.svg)](https://npmjs.org/package/mega-linter-runner)
[![GitHub stars](https://img.shields.io/github/stars/megalinter/megalinter?maxAge=2592000)](https://GitHub.com/megalinter/megalinter/stargazers/)
<!-- readme-header-start -->
[![Docker Pulls](https://img.shields.io/badge/docker%20pulls-3.3M-blue)](https://megalinter.github.io/flavors/)
[![MegaLinter](https://github.com/megalinter/megalinter/workflows/MegaLinter/badge.svg?branch=main)](https://megalinter.github.io)
[![codecov](https://codecov.io/gh/megalinter/megalinter/branch/master/graph/badge.svg)](https://codecov.io/gh/megalinter/megalinter)
[![Secured with Trivy](https://img.shields.io/badge/Trivy-secured-green?logo=docker)](https://github.com/aquasecurity/trivy)
[![GitHub Sponsors](https://img.shields.io/github/sponsors/nvuillam)](https://github.com/sponsors/nvuillam)
[![PRs Welcome](https://img.shields.io/badge/PRs-welcome-brightgreen.svg?style=flat-square)](http://makeapullrequest.com)
[![Tweet](https://img.shields.io/twitter/url/http/shields.io.svg?style=social)](https://twitter.com/intent/tweet?text=Check+MegaLinter+to+say+goodbye+to+dirty+code+in+your+projects+%3A%29+100%25+free+and+open+source+for+all+uses&url=https://megalinter.github.io/&via=NicolasVuillamy&hashtags=linters,code,quality,ci,python,java,golang,c,dotnet,kotlin,rust,scala,salesforce,terraform)

<!-- welcome-phrase-start -->
**MegaLinter** analyzes [**37 languages**](#languages), [**15 formats**](#formats), [**16 tooling formats**](#tooling-formats) , [**copy-pastes**](#other) and [**spell**](#other) in your repository sources, generate [**reports in several formats**](#reports), and can even [**apply formatting and auto-fixes**](#apply-fixes) with **auto-generated commit or PR**, to ensure all your projects are clean, whatever IDE/toolbox are used by their developers !
<!-- welcome-phrase-end -->

<!-- online-doc-start -->
See [**MegaLinter Online Documentation Web Site**](https://megalinter.github.io/)
<!-- online-doc-end -->

<!-- readme-header-end -->

This package allows to run [MegaLinter](https://megalinter.github.io/) locally before running it in your CD/CI workflow, or simply to locally apply reformatting and fixes without having to install up to date linters for your files

![Screenshot](https://github.com/megalinter/megalinter/blob/main/docs/assets/images/ConsoleReporter.jpg?raw=true>)

## Installation

### Pre-requisites

You need to have [NodeJS](https://nodejs.org/en/) and [Docker](https://www.docker.com/) installed on your computer to run MegaLinter locally with MegaLinter Runner

### Global installation

```shell
npm install mega-linter-runner -g
```

### Local installation

```shell
npm install mega-linter-runner --save-dev
```

### No installation

You can run mega-linter-runner without installation by using `npx`

Example:

```shell
npx mega-linter-runner -r beta -e 'ENABLE=MARKDOWN,YAML' -e 'SHOW_ELAPSED_TIME=true'
```

### Pre-commit hook

You can run mega-linter-runner as a [pre-commit](https://pre-commit.com/) hook

Sample `.pre-commit-config.yaml`:

```yaml
repos:
  - repo: https://github.com/megalinter/megalinter
    rev: v5.12.0 # Git tag specifying the hook, not mega-linter-runner, version
    hooks:
      - id: megalinter # Faster, less thorough, runs pre-commit by default
      - id: megalinter-all # Slower, more thorough, runs pre-push by default
```

See [`.pre-commit-hooks.yaml`](../.pre-commit-hooks.yaml) for more details.

## Usage

```shell
mega-linter-runner [OPTIONS]
```

The options are only related to mega-linter-runner. For MegaLinter options, please use a `.mega-linter.yml` [configuration file](#configuration)

| Option                 | Description                                                                                                        | Default           |
|------------------------|--------------------------------------------------------------------------------------------------------------------|-------------------|
| `-p` <br/> `--path`    | Directory containing the files to lint                                                                             | current directory |
| `--flavor`             | Set this parameter to use a [MegaLinter flavor](https://megalinter.github.io/flavors/)                             | `all`             |
| `-d` <br/> `--image`   | You can override the used docker image, including if it is on another docker registry                              | <!-- -->          |
| `-e` <br/> `--env`     | Environment variables for MegaLinter, following format **'ENV_VAR_NAME=VALUE'** <br/>Warning: Quotes are mandatory | <!-- -->          |
| `--fix`                | Automatically apply formatting and fixes in your files                                                             | <!-- -->          |
| `-r` <br/> `--release` | Allows to override MegaLinter version used                                                                         | `v5`              |
| `-h` <br/> `--help`    | Show mega-linter-runner help                                                                                       | <!-- -->          |
| `-v` <br/> `--version` | Show mega-linter-runner version                                                                                    | <!-- -->          |
| `-i` <br/> `--install` | Generate MegaLinter configuration files                                                                            | <!-- -->          |
| `--containername`      | Specify MegaLinter container name                                                                                  | <!-- -->          |

_You can also use `npx mega-linter-runner` if you do not want to install the package_

### Examples

```shell
mega-linter-runner
```

```shell
mega-linter-runner -p myFolder --fix
```

```shell
mega-linter-runner -r beta -e 'ENABLE=MARKDOWN,YAML' -e 'SHOW_ELAPSED_TIME=true'
```

## Configuration

You can generate a ready-to-use [.mega-linter.yml configuration file](https://megalinter.github.io/configuration/) by running `npx mega-linter-runner --install` at the root of your repository

![Runner Install](https://github.com/megalinter/megalinter/blob/main/docs/assets/images/mega-linter-runner-generator.gif?raw=true)

<!-- linters-section-start -->
## Linters

<!-- linters-table-start -->
### Languages

|                                                                               <!-- -->                                                                               | Language                                                                                                                   | Linter                                                                                                                          | Configuration key                                                                                                                          |     Format/Fix     |                                                                           Status                                                                           |
|:--------------------------------------------------------------------------------------------------------------------------------------------------------------------:|----------------------------------------------------------------------------------------------------------------------------|---------------------------------------------------------------------------------------------------------------------------------|--------------------------------------------------------------------------------------------------------------------------------------------|:------------------:|:----------------------------------------------------------------------------------------------------------------------------------------------------------:|
|    <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/bash.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon -->    | [**BASH**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/bash.md#readme)                             | [bash-exec](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/bash_bash_exec.md#readme)                       | [BASH_EXEC](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/bash_bash_exec.md#readme)                                  |                    |                                                                                                                                                            |
|                                                                    <!-- --> <!-- linter-icon -->                                                                     |                                                                                                                            | [shellcheck](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/bash_shellcheck.md#readme)                     | [BASH_SHELLCHECK](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/bash_shellcheck.md#readme)                           |                    |           [![GitHub last commit](https://img.shields.io/github/last-commit/koalaman/shellcheck)](https://github.com/koalaman/shellcheck/commits)           |
|                                                                    <!-- --> <!-- linter-icon -->                                                                     |                                                                                                                            | [shfmt](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/bash_shfmt.md#readme)                               | [BASH_SHFMT](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/bash_shfmt.md#readme)                                     | :heavy_check_mark: |                      [![GitHub last commit](https://img.shields.io/github/last-commit/mvdan/sh)](https://github.com/mvdan/sh/commits)                      |
|     <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/c.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon -->      | [**C**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/c.md#readme)                                   | [cpplint](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/c_cpplint.md#readme)                              | [C_CPPLINT](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/c_cpplint.md#readme)                                       |                    |               [![GitHub last commit](https://img.shields.io/github/last-commit/cpplint/cpplint)](https://github.com/cpplint/cpplint/commits)               |
|  <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/clojure.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon -->   | [**CLOJURE**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/clojure.md#readme)                       | [clj-kondo](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/clojure_clj_kondo.md#readme)                    | [CLOJURE_CLJ_KONDO](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/clojure_clj_kondo.md#readme)                       |                    |            [![GitHub last commit](https://img.shields.io/github/last-commit/borkdude/clj-kondo)](https://github.com/borkdude/clj-kondo/commits)            |
|   <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/coffee.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon -->   | [**COFFEE**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/coffee.md#readme)                         | [coffeelint](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/coffee_coffeelint.md#readme)                   | [COFFEE_COFFEELINT](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/coffee_coffeelint.md#readme)                       |                    |          [![GitHub last commit](https://img.shields.io/github/last-commit/clutchski/coffeelint)](https://github.com/clutchski/coffeelint/commits)          |
|    <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/cpp.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon -->     | [**C++** (CPP)](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/cpp.md#readme)                         | [cpplint](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/cpp_cpplint.md#readme)                            | [CPP_CPPLINT](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/cpp_cpplint.md#readme)                                   |                    |               [![GitHub last commit](https://img.shields.io/github/last-commit/cpplint/cpplint)](https://github.com/cpplint/cpplint/commits)               |
|   <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/csharp.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon -->   | [**C#** (CSHARP)](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/csharp.md#readme)                    | [dotnet-format](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/csharp_dotnet_format.md#readme)             | [CSHARP_DOTNET_FORMAT](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/csharp_dotnet_format.md#readme)                 | :heavy_check_mark: |                 [![GitHub last commit](https://img.shields.io/github/last-commit/dotnet/format)](https://github.com/dotnet/format/commits)                 |
|    <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/dart.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon -->    | [**DART**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/dart.md#readme)                             | [dartanalyzer](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/dart_dartanalyzer.md#readme)                 | [DART_DARTANALYZER](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/dart_dartanalyzer.md#readme)                       |                    |                 [![GitHub last commit](https://img.shields.io/github/last-commit/dart-lang/sdk)](https://github.com/dart-lang/sdk/commits)                 |
|     <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/go.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon -->     | [**GO**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/go.md#readme)                                 | [golangci-lint](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/go_golangci_lint.md#readme)                 | [GO_GOLANGCI_LINT](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/go_golangci_lint.md#readme)                         |                    |        [![GitHub last commit](https://img.shields.io/github/last-commit/golangci/golangci-lint)](https://github.com/golangci/golangci-lint/commits)        |
|                                                                    <!-- --> <!-- linter-icon -->                                                                     |                                                                                                                            | [revive](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/go_revive.md#readme)                               | [GO_REVIVE](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/go_revive.md#readme)                                       |                    |                [![GitHub last commit](https://img.shields.io/github/last-commit/mgechev/revive)](https://github.com/mgechev/revive/commits)                |
|   <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/groovy.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon -->   | [**GROOVY**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/groovy.md#readme)                         | [npm-groovy-lint](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/groovy_npm_groovy_lint.md#readme)         | [GROOVY_NPM_GROOVY_LINT](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/groovy_npm_groovy_lint.md#readme)             | :heavy_check_mark: |      [![GitHub last commit](https://img.shields.io/github/last-commit/nvuillam/npm-groovy-lint)](https://github.com/nvuillam/npm-groovy-lint/commits)      |
|    <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/java.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon -->    | [**JAVA**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/java.md#readme)                             | [checkstyle](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/java_checkstyle.md#readme)                     | [JAVA_CHECKSTYLE](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/java_checkstyle.md#readme)                           |                    |         [![GitHub last commit](https://img.shields.io/github/last-commit/checkstyle/checkstyle)](https://github.com/checkstyle/checkstyle/commits)         |
| <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/javascript.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon --> | [**JAVASCRIPT**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/javascript.md#readme)                 | [eslint](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/javascript_eslint.md#readme)                       | [JAVASCRIPT_ES](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/javascript_eslint.md#readme)                           | :heavy_check_mark: |                 [![GitHub last commit](https://img.shields.io/github/last-commit/eslint/eslint)](https://github.com/eslint/eslint/commits)                 |
|                                                                    <!-- --> <!-- linter-icon -->                                                                     |                                                                                                                            | [standard](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/javascript_standard.md#readme)                   | [JAVASCRIPT_STANDARD](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/javascript_standard.md#readme)                   | :heavy_check_mark: |             [![GitHub last commit](https://img.shields.io/github/last-commit/standard/standard)](https://github.com/standard/standard/commits)             |
|                                                                    <!-- --> <!-- linter-icon -->                                                                     |                                                                                                                            | [prettier](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/javascript_prettier.md#readme)                   | [JAVASCRIPT_PRETTIER](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/javascript_prettier.md#readme)                   | :heavy_check_mark: |             [![GitHub last commit](https://img.shields.io/github/last-commit/prettier/prettier)](https://github.com/prettier/prettier/commits)             |
|    <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/jsx.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon -->     | [**JSX**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/jsx.md#readme)                               | [eslint](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/jsx_eslint.md#readme)                              | [JSX_ESLINT](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/jsx_eslint.md#readme)                                     | :heavy_check_mark: | [![GitHub last commit](https://img.shields.io/github/last-commit/yannickcr/eslint-plugin-react)](https://github.com/yannickcr/eslint-plugin-react/commits) |
|   <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/kotlin.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon -->   | [**KOTLIN**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/kotlin.md#readme)                         | [ktlint](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/kotlin_ktlint.md#readme)                           | [KOTLIN_KTLINT](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/kotlin_ktlint.md#readme)                               | :heavy_check_mark: |              [![GitHub last commit](https://img.shields.io/github/last-commit/pinterest/ktlint)](https://github.com/pinterest/ktlint/commits)              |
|    <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/lua.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon -->     | [**LUA**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/lua.md#readme)                               | [luacheck](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/lua_luacheck.md#readme)                          | [LUA_LUACHECK](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/lua_luacheck.md#readme)                                 |                    |             [![GitHub last commit](https://img.shields.io/github/last-commit/luarocks/luacheck)](https://github.com/luarocks/luacheck/commits)             |
|    <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/perl.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon -->    | [**PERL**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/perl.md#readme)                             | [perlcritic](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/perl_perlcritic.md#readme)                     | [PERL_PERLCRITIC](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/perl_perlcritic.md#readme)                           |                    |       [![GitHub last commit](https://img.shields.io/github/last-commit/Perl-Critic/Perl-Critic)](https://github.com/Perl-Critic/Perl-Critic/commits)       |
|    <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/php.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon -->     | [**PHP**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/php.md#readme)                               | [php](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/php_php.md#readme)                                    | [PHP_BUILTIN](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/php_php.md#readme)                                       |                    |                   [![GitHub last commit](https://img.shields.io/github/last-commit/php/php-src)](https://github.com/php/php-src/commits)                   |
|                                                                    <!-- --> <!-- linter-icon -->                                                                     |                                                                                                                            | [phpcs](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/php_phpcs.md#readme)                                | [PHP_PHPCS](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/php_phpcs.md#readme)                                       |                    |     [![GitHub last commit](https://img.shields.io/github/last-commit/squizlabs/PHP_CodeSniffer)](https://github.com/squizlabs/PHP_CodeSniffer/commits)     |
|                                                                    <!-- --> <!-- linter-icon -->                                                                     |                                                                                                                            | [phpstan](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/php_phpstan.md#readme)                            | [PHP_PHPSTAN](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/php_phpstan.md#readme)                                   |                    |               [![GitHub last commit](https://img.shields.io/github/last-commit/phpstan/phpstan)](https://github.com/phpstan/phpstan/commits)               |
|                                                                    <!-- --> <!-- linter-icon -->                                                                     |                                                                                                                            | [psalm](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/php_psalm.md#readme)                                | [PHP_PSALM](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/php_psalm.md#readme)                                       |                    |                   [![GitHub last commit](https://img.shields.io/github/last-commit/vimeo/psalm)](https://github.com/vimeo/psalm/commits)                   |
|                                                                    <!-- --> <!-- linter-icon -->                                                                     |                                                                                                                            | [phplint](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/php_phplint.md#readme)                            | [PHP_PHPLINT](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/php_phplint.md#readme)                                   |                    |              [![GitHub last commit](https://img.shields.io/github/last-commit/overtrue/phplint)](https://github.com/overtrue/phplint/commits)              |
| <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/powershell.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon --> | [**POWERSHELL**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/powershell.md#readme)                 | [powershell](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/powershell_powershell.md#readme)               | [POWERSHELL_POWERSHELL](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/powershell_powershell.md#readme)               |                    |   [![GitHub last commit](https://img.shields.io/github/last-commit/PowerShell/PSScriptAnalyzer)](https://github.com/PowerShell/PSScriptAnalyzer/commits)   |
|   <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/python.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon -->   | [**PYTHON**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/python.md#readme)                         | [pylint](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/python_pylint.md#readme)                           | [PYTHON_PYLINT](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/python_pylint.md#readme)                               |                    |                  [![GitHub last commit](https://img.shields.io/github/last-commit/PyCQA/pylint)](https://github.com/PyCQA/pylint/commits)                  |
|                                                                    <!-- --> <!-- linter-icon -->                                                                     |                                                                                                                            | [black](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/python_black.md#readme)                             | [PYTHON_BLACK](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/python_black.md#readme)                                 | :heavy_check_mark: |                     [![GitHub last commit](https://img.shields.io/github/last-commit/psf/black)](https://github.com/psf/black/commits)                     |
|                                                                    <!-- --> <!-- linter-icon -->                                                                     |                                                                                                                            | [flake8](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/python_flake8.md#readme)                           | [PYTHON_FLAKE8](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/python_flake8.md#readme)                               |                    |                  [![GitHub last commit](https://img.shields.io/github/last-commit/PyCQA/flake8)](https://github.com/PyCQA/flake8/commits)                  |
|                                                                    <!-- --> <!-- linter-icon -->                                                                     |                                                                                                                            | [isort](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/python_isort.md#readme)                             | [PYTHON_ISORT](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/python_isort.md#readme)                                 | :heavy_check_mark: |                   [![GitHub last commit](https://img.shields.io/github/last-commit/PyCQA/isort)](https://github.com/PyCQA/isort/commits)                   |
|                                                                    <!-- --> <!-- linter-icon -->                                                                     |                                                                                                                            | [bandit](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/python_bandit.md#readme)                           | [PYTHON_BANDIT](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/python_bandit.md#readme)                               |                    |                  [![GitHub last commit](https://img.shields.io/github/last-commit/PyCQA/bandit)](https://github.com/PyCQA/bandit/commits)                  |
|                                                                    <!-- --> <!-- linter-icon -->                                                                     |                                                                                                                            | [mypy](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/python_mypy.md#readme)                               | [PYTHON_MYPY](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/python_mypy.md#readme)                                   |                    |                   [![GitHub last commit](https://img.shields.io/github/last-commit/python/mypy)](https://github.com/python/mypy/commits)                   |
|     <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/r.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon -->      | [**R**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/r.md#readme)                                   | [lintr](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/r_lintr.md#readme)                                  | [R_LINTR](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/r_lintr.md#readme)                                           |                    |                                                                                                                                                            |
|    <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/raku.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon -->    | [**RAKU**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/raku.md#readme)                             | [raku](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/raku_raku.md#readme)                                 | [RAKU_RAKU](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/raku_raku.md#readme)                                       |                    |                 [![GitHub last commit](https://img.shields.io/github/last-commit/rakudo/rakudo)](https://github.com/rakudo/rakudo/commits)                 |
|    <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/ruby.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon -->    | [**RUBY**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/ruby.md#readme)                             | [rubocop](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/ruby_rubocop.md#readme)                           | [RUBY_RUBOCOP](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/ruby_rubocop.md#readme)                                 | :heavy_check_mark: |            [![GitHub last commit](https://img.shields.io/github/last-commit/rubocop-hq/rubocop)](https://github.com/rubocop-hq/rubocop/commits)            |
|    <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/rust.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon -->    | [**RUST**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/rust.md#readme)                             | [clippy](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/rust_clippy.md#readme)                             | [RUST_CLIPPY](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/rust_clippy.md#readme)                                   |                    |         [![GitHub last commit](https://img.shields.io/github/last-commit/rust-lang/rust-clippy)](https://github.com/rust-lang/rust-clippy/commits)         |
| <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/salesforce.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon --> | [**SALESFORCE**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/salesforce.md#readme)                 | [sfdx-scanner-apex](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/salesforce_sfdx_scanner_apex.md#readme) | [SALESFORCE_SFDX_SCANNER_APEX](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/salesforce_sfdx_scanner_apex.md#readme) |                    |      [![GitHub last commit](https://img.shields.io/github/last-commit/forcedotcom/sfdx-scanner)](https://github.com/forcedotcom/sfdx-scanner/commits)      |
|                                                                    <!-- --> <!-- linter-icon -->                                                                     |                                                                                                                            | [sfdx-scanner-aura](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/salesforce_sfdx_scanner_aura.md#readme) | [SALESFORCE_SFDX_SCANNER_AURA](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/salesforce_sfdx_scanner_aura.md#readme) |                    |      [![GitHub last commit](https://img.shields.io/github/last-commit/forcedotcom/sfdx-scanner)](https://github.com/forcedotcom/sfdx-scanner/commits)      |
|                                                                    <!-- --> <!-- linter-icon -->                                                                     |                                                                                                                            | [sfdx-scanner-lwc](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/salesforce_sfdx_scanner_lwc.md#readme)   | [SALESFORCE_SFDX_SCANNER_LWC](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/salesforce_sfdx_scanner_lwc.md#readme)   |                    |      [![GitHub last commit](https://img.shields.io/github/last-commit/forcedotcom/sfdx-scanner)](https://github.com/forcedotcom/sfdx-scanner/commits)      |
|   <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/scala.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon -->    | [**SCALA**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/scala.md#readme)                           | [scalafix](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/scala_scalafix.md#readme)                        | [SCALA_SCALAFIX](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/scala_scalafix.md#readme)                             |                    |          [![GitHub last commit](https://img.shields.io/github/last-commit/scalacenter/scalafix)](https://github.com/scalacenter/scalafix/commits)          |
|    <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/sql.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon -->     | [**SQL**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/sql.md#readme)                               | [sql-lint](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/sql_sql_lint.md#readme)                          | [SQL_SQL_LINT](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/sql_sql_lint.md#readme)                                 |                    |          [![GitHub last commit](https://img.shields.io/github/last-commit/joereynolds/sql-lint)](https://github.com/joereynolds/sql-lint/commits)          |
|                                                                    <!-- --> <!-- linter-icon -->                                                                     |                                                                                                                            | [sqlfluff](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/sql_sqlfluff.md#readme)                          | [SQL_SQLFLUFF](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/sql_sqlfluff.md#readme)                                 |                    |             [![GitHub last commit](https://img.shields.io/github/last-commit/sqlfluff/sqlfluff)](https://github.com/sqlfluff/sqlfluff/commits)             |
|                                                                    <!-- --> <!-- linter-icon -->                                                                     |                                                                                                                            | [tsqllint](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/sql_tsqllint.md#readme)                          | [SQL_TSQLLINT](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/sql_tsqllint.md#readme)                                 |                    |             [![GitHub last commit](https://img.shields.io/github/last-commit/tsqllint/tsqllint)](https://github.com/tsqllint/tsqllint/commits)             |
|  <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/default.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon -->   | [**SWIFT**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/swift.md#readme)                           | [swiftlint](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/swift_swiftlint.md#readme)                      | [SWIFT_SWIFTLINT](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/swift_swiftlint.md#readme)                           | :heavy_check_mark: |               [![GitHub last commit](https://img.shields.io/github/last-commit/realm/SwiftLint)](https://github.com/realm/SwiftLint/commits)               |
|    <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/tsx.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon -->     | [**TSX**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/tsx.md#readme)                               | [eslint](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/tsx_eslint.md#readme)                              | [TSX_ESLINT](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/tsx_eslint.md#readme)                                     | :heavy_check_mark: | [![GitHub last commit](https://img.shields.io/github/last-commit/yannickcr/eslint-plugin-react)](https://github.com/yannickcr/eslint-plugin-react/commits) |
| <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/typescript.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon --> | [**TYPESCRIPT**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/typescript.md#readme)                 | [eslint](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/typescript_eslint.md#readme)                       | [TYPESCRIPT_ES](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/typescript_eslint.md#readme)                           | :heavy_check_mark: |                 [![GitHub last commit](https://img.shields.io/github/last-commit/eslint/eslint)](https://github.com/eslint/eslint/commits)                 |
|                                                                    <!-- --> <!-- linter-icon -->                                                                     |                                                                                                                            | [standard](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/typescript_standard.md#readme)                   | [TYPESCRIPT_STANDARD](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/typescript_standard.md#readme)                   | :heavy_check_mark: |             [![GitHub last commit](https://img.shields.io/github/last-commit/standard/standard)](https://github.com/standard/standard/commits)             |
|                                                                    <!-- --> <!-- linter-icon -->                                                                     |                                                                                                                            | [prettier](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/typescript_prettier.md#readme)                   | [TYPESCRIPT_PRETTIER](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/typescript_prettier.md#readme)                   | :heavy_check_mark: |             [![GitHub last commit](https://img.shields.io/github/last-commit/prettier/prettier)](https://github.com/prettier/prettier/commits)             |
|  <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/vbdotnet.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon -->  | [**Visual Basic .NET** (VBDOTNET)](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/vbdotnet.md#readme) | [dotnet-format](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/vbdotnet_dotnet_format.md#readme)           | [VBDOTNET_DOTNET_FORMAT](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/vbdotnet_dotnet_format.md#readme)             | :heavy_check_mark: |                 [![GitHub last commit](https://img.shields.io/github/last-commit/dotnet/format)](https://github.com/dotnet/format/commits)                 |

### Formats

|                                                                              <!-- -->                                                                              | Format                                                                                                 | Linter                                                                                                                                      | Configuration key                                                                                                                                    |     Format/Fix     |                                                                               Status                                                                               |
|:------------------------------------------------------------------------------------------------------------------------------------------------------------------:|--------------------------------------------------------------------------------------------------------|---------------------------------------------------------------------------------------------------------------------------------------------|------------------------------------------------------------------------------------------------------------------------------------------------------|:------------------:|:------------------------------------------------------------------------------------------------------------------------------------------------------------------:|
|   <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/css.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon -->    | [**CSS**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/css.md#readme)           | [stylelint](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/css_stylelint.md#readme)                                    | [CSS_STYLELINT](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/css_stylelint.md#readme)                                         | :heavy_check_mark: |               [![GitHub last commit](https://img.shields.io/github/last-commit/stylelint/stylelint)](https://github.com/stylelint/stylelint/commits)               |
|                                                                   <!-- --> <!-- linter-icon -->                                                                    |                                                                                                        | [scss-lint](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/css_scss_lint.md#readme)                                    | [CSS_SCSS_LINT](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/css_scss_lint.md#readme)                                         |                    |                     [![GitHub last commit](https://img.shields.io/github/last-commit/sds/scss-lint)](https://github.com/sds/scss-lint/commits)                     |
|   <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/env.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon -->    | [**ENV**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/env.md#readme)           | [dotenv-linter](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/env_dotenv_linter.md#readme)                            | [ENV_DOTENV_LINTER](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/env_dotenv_linter.md#readme)                                 | :heavy_check_mark: |       [![GitHub last commit](https://img.shields.io/github/last-commit/dotenv-linter/dotenv-linter)](https://github.com/dotenv-linter/dotenv-linter/commits)       |
| <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/graphql.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon -->  | [**GRAPHQL**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/graphql.md#readme)   | [graphql-schema-linter](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/graphql_graphql_schema_linter.md#readme)        | [GRAPHQL_GRAPHQL_SCHEMA_LINTER](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/graphql_graphql_schema_linter.md#readme)         |                    |    [![GitHub last commit](https://img.shields.io/github/last-commit/cjoudrey/graphql-schema-linter)](https://github.com/cjoudrey/graphql-schema-linter/commits)    |
|   <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/html.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon -->   | [**HTML**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/html.md#readme)         | [htmlhint](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/html_htmlhint.md#readme)                                     | [HTML_HTMLHINT](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/html_htmlhint.md#readme)                                         |                    |                 [![GitHub last commit](https://img.shields.io/github/last-commit/htmlhint/HTMLHint)](https://github.com/htmlhint/HTMLHint/commits)                 |
|   <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/json.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon -->   | [**JSON**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/json.md#readme)         | [jsonlint](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/json_jsonlint.md#readme)                                     | [JSON_JSONLINT](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/json_jsonlint.md#readme)                                         |                    |                    [![GitHub last commit](https://img.shields.io/github/last-commit/zaach/jsonlint)](https://github.com/zaach/jsonlint/commits)                    |
|                                                                   <!-- --> <!-- linter-icon -->                                                                    |                                                                                                        | [eslint-plugin-jsonc](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/json_eslint_plugin_jsonc.md#readme)               | [JSON_ESLINT_PLUGIN_JSONC](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/json_eslint_plugin_jsonc.md#readme)                   | :heavy_check_mark: |     [![GitHub last commit](https://img.shields.io/github/last-commit/ota-meshi/eslint-plugin-jsonc)](https://github.com/ota-meshi/eslint-plugin-jsonc/commits)     |
|                                                                   <!-- --> <!-- linter-icon -->                                                                    |                                                                                                        | [v8r](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/json_v8r.md#readme)                                               | [JSON_V8R](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/json_v8r.md#readme)                                                   |                    |                      [![GitHub last commit](https://img.shields.io/github/last-commit/chris48s/v8r)](https://github.com/chris48s/v8r/commits)                      |
|                                                                   <!-- --> <!-- linter-icon -->                                                                    |                                                                                                        | [prettier](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/json_prettier.md#readme)                                     | [JSON_PRETTIER](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/json_prettier.md#readme)                                         | :heavy_check_mark: |                 [![GitHub last commit](https://img.shields.io/github/last-commit/prettier/prettier)](https://github.com/prettier/prettier/commits)                 |
|  <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/latex.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon -->   | [**LATEX**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/latex.md#readme)       | [chktex](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/latex_chktex.md#readme)                                        | [LATEX_CHKTEX](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/latex_chktex.md#readme)                                           |                    |                                                                                                                                                                    |
| <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/markdown.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon --> | [**MARKDOWN**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/markdown.md#readme) | [markdownlint](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/markdown_markdownlint.md#readme)                         | [MARKDOWN_MARKDOWNLINT](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/markdown_markdownlint.md#readme)                         | :heavy_check_mark: |           [![GitHub last commit](https://img.shields.io/github/last-commit/DavidAnson/markdownlint)](https://github.com/DavidAnson/markdownlint/commits)           |
|                                                                   <!-- --> <!-- linter-icon -->                                                                    |                                                                                                        | [remark-lint](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/markdown_remark_lint.md#readme)                           | [MARKDOWN_REMARK_LINT](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/markdown_remark_lint.md#readme)                           | :heavy_check_mark: |              [![GitHub last commit](https://img.shields.io/github/last-commit/remarkjs/remark-lint)](https://github.com/remarkjs/remark-lint/commits)              |
|                                                                   <!-- --> <!-- linter-icon -->                                                                    |                                                                                                        | [markdown-link-check](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/markdown_markdown_link_check.md#readme)           | [MARKDOWN_MARKDOWN_LINK_CHECK](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/markdown_markdown_link_check.md#readme)           |                    |         [![GitHub last commit](https://img.shields.io/github/last-commit/tcort/markdown-link-check)](https://github.com/tcort/markdown-link-check/commits)         |
|                                                                   <!-- --> <!-- linter-icon -->                                                                    |                                                                                                        | [markdown-table-formatter](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/markdown_markdown_table_formatter.md#readme) | [MARKDOWN_MARKDOWN_TABLE_FORMATTER](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/markdown_markdown_table_formatter.md#readme) | :heavy_check_mark: | [![GitHub last commit](https://img.shields.io/github/last-commit/nvuillam/markdown-table-formatter)](https://github.com/nvuillam/markdown-table-formatter/commits) |
| <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/protobuf.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon --> | [**PROTOBUF**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/protobuf.md#readme) | [protolint](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/protobuf_protolint.md#readme)                               | [PROTOBUF_PROTOLINT](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/protobuf_protolint.md#readme)                               | :heavy_check_mark: |               [![GitHub last commit](https://img.shields.io/github/last-commit/yoheimuta/protolint)](https://github.com/yoheimuta/protolint/commits)               |
|   <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/rst.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon -->    | [**RST**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/rst.md#readme)           | [rst-lint](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/rst_rst_lint.md#readme)                                      | [RST_RST_LINT](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/rst_rst_lint.md#readme)                                           |                    |    [![GitHub last commit](https://img.shields.io/github/last-commit/twolfson/restructuredtext-lint)](https://github.com/twolfson/restructuredtext-lint/commits)    |
|                                                                   <!-- --> <!-- linter-icon -->                                                                    |                                                                                                        | [rstcheck](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/rst_rstcheck.md#readme)                                      | [RST_RSTCHECK](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/rst_rstcheck.md#readme)                                           |                    |                    [![GitHub last commit](https://img.shields.io/github/last-commit/myint/rstcheck)](https://github.com/myint/rstcheck/commits)                    |
|                                                                   <!-- --> <!-- linter-icon -->                                                                    |                                                                                                        | [rstfmt](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/rst_rstfmt.md#readme)                                          | [RST_RSTFMT](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/rst_rstfmt.md#readme)                                               | :heavy_check_mark: |                       [![GitHub last commit](https://img.shields.io/github/last-commit/dzhu/rstfmt)](https://github.com/dzhu/rstfmt/commits)                       |
|   <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/xml.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon -->    | [**XML**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/xml.md#readme)           | [xmllint](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/xml_xmllint.md#readme)                                        | [XML_XMLLINT](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/xml_xmllint.md#readme)                                             |                    |                                                                                                                                                                    |
|   <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/yaml.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon -->   | [**YAML**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/yaml.md#readme)         | [prettier](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/yaml_prettier.md#readme)                                     | [YAML_PRETTIER](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/yaml_prettier.md#readme)                                         | :heavy_check_mark: |                 [![GitHub last commit](https://img.shields.io/github/last-commit/prettier/prettier)](https://github.com/prettier/prettier/commits)                 |
|                                                                   <!-- --> <!-- linter-icon -->                                                                    |                                                                                                        | [yamllint](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/yaml_yamllint.md#readme)                                     | [YAML_YAMLLINT](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/yaml_yamllint.md#readme)                                         |                    |              [![GitHub last commit](https://img.shields.io/github/last-commit/adrienverge/yamllint)](https://github.com/adrienverge/yamllint/commits)              |
|                                                                   <!-- --> <!-- linter-icon -->                                                                    |                                                                                                        | [v8r](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/yaml_v8r.md#readme)                                               | [YAML_V8R](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/yaml_v8r.md#readme)                                                   |                    |                      [![GitHub last commit](https://img.shields.io/github/last-commit/chris48s/v8r)](https://github.com/chris48s/v8r/commits)                      |

### Tooling formats

|                                                                                 <!-- -->                                                                                 | Tooling format                                                                                                     | Linter                                                                                                                                  | Configuration key                                                                                                                                    |     Format/Fix     |                                                                                       Status                                                                                       |
|:------------------------------------------------------------------------------------------------------------------------------------------------------------------------:|--------------------------------------------------------------------------------------------------------------------|-----------------------------------------------------------------------------------------------------------------------------------------|------------------------------------------------------------------------------------------------------------------------------------------------------|:------------------:|:----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------:|
|    <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/default.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon -->     | [**ACTION**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/action.md#readme)                 | [actionlint](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/action_actionlint.md#readme)                           | [ACTION_ACTIONLINT](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/action_actionlint.md#readme)                                 |                    |                          [![GitHub last commit](https://img.shields.io/github/last-commit/rhysd/actionlint)](https://github.com/rhysd/actionlint/commits)                          |
|    <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/ansible.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon -->     | [**ANSIBLE**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/ansible.md#readme)               | [ansible-lint](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/ansible_ansible_lint.md#readme)                      | [ANSIBLE_ANSIBLE_LINT](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/ansible_ansible_lint.md#readme)                           |                    |                      [![GitHub last commit](https://img.shields.io/github/last-commit/ansible/ansible-lint)](https://github.com/ansible/ansible-lint/commits)                      |
|      <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/arm.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon -->       | [**ARM**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/arm.md#readme)                       | [arm-ttk](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/arm_arm_ttk.md#readme)                                    | [ARM_ARM_TTK](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/arm_arm_ttk.md#readme)                                             |                    |                             [![GitHub last commit](https://img.shields.io/github/last-commit/Azure/arm-ttk)](https://github.com/Azure/arm-ttk/commits)                             |
| <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/cloudformation.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon --> | [**CLOUDFORMATION**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/cloudformation.md#readme) | [cfn-lint](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/cloudformation_cfn_lint.md#readme)                       | [CLOUDFORMATION_CFN_LINT](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/cloudformation_cfn_lint.md#readme)                     |                    |                       [![GitHub last commit](https://img.shields.io/github/last-commit/martysweet/cfn-lint)](https://github.com/martysweet/cfn-lint/commits)                       |
|   <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/dockerfile.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon -->   | [**DOCKERFILE**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/dockerfile.md#readme)         | [dockerfilelint](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/dockerfile_dockerfilelint.md#readme)               | [DOCKERFILE_DOCKERFILELINT](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/dockerfile_dockerfilelint.md#readme)                 |                    |               [![GitHub last commit](https://img.shields.io/github/last-commit/replicatedhq/dockerfilelint)](https://github.com/replicatedhq/dockerfilelint/commits)               |
|                                                                      <!-- --> <!-- linter-icon -->                                                                       |                                                                                                                    | [hadolint](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/dockerfile_hadolint.md#readme)                           | [DOCKERFILE_HADOLINT](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/dockerfile_hadolint.md#readme)                             |                    |                         [![GitHub last commit](https://img.shields.io/github/last-commit/hadolint/hadolint)](https://github.com/hadolint/hadolint/commits)                         |
|  <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/editorconfig.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon -->  | [**EDITORCONFIG**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/editorconfig.md#readme)     | [editorconfig-checker](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/editorconfig_editorconfig_checker.md#readme) | [EDITORCONFIG_EDITORCONFIG_CHECKER](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/editorconfig_editorconfig_checker.md#readme) |                    | [![GitHub last commit](https://img.shields.io/github/last-commit/editorconfig-checker/editorconfig-checker)](https://github.com/editorconfig-checker/editorconfig-checker/commits) |
|    <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/gherkin.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon -->     | [**GHERKIN**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/gherkin.md#readme)               | [gherkin-lint](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/gherkin_gherkin_lint.md#readme)                      | [GHERKIN_GHERKIN_LINT](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/gherkin_gherkin_lint.md#readme)                           |                    |                      [![GitHub last commit](https://img.shields.io/github/last-commit/vsiakka/gherkin-lint)](https://github.com/vsiakka/gherkin-lint/commits)                      |
|   <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/kubernetes.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon -->   | [**KUBERNETES**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/kubernetes.md#readme)         | [kubeval](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/kubernetes_kubeval.md#readme)                             | [KUBERNETES_KUBEVAL](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/kubernetes_kubeval.md#readme)                               |                    |                       [![GitHub last commit](https://img.shields.io/github/last-commit/instrumenta/kubeval)](https://github.com/instrumenta/kubeval/commits)                       |
|                                                                      <!-- --> <!-- linter-icon -->                                                                       |                                                                                                                    | [kubeconform](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/kubernetes_kubeconform.md#readme)                     | [KUBERNETES_KUBECONFORM](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/kubernetes_kubeconform.md#readme)                       |                    |                         [![GitHub last commit](https://img.shields.io/github/last-commit/yannh/kubeconform)](https://github.com/yannh/kubeconform/commits)                         |
|    <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/openapi.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon -->     | [**OPENAPI**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/openapi.md#readme)               | [spectral](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/openapi_spectral.md#readme)                              | [OPENAPI_SPECTRAL](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/openapi_spectral.md#readme)                                   |                    |                      [![GitHub last commit](https://img.shields.io/github/last-commit/stoplightio/spectral)](https://github.com/stoplightio/spectral/commits)                      |
|     <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/puppet.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon -->     | [**PUPPET**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/puppet.md#readme)                 | [puppet-lint](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/puppet_puppet_lint.md#readme)                         | [PUPPET_PUPPET_LINT](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/puppet_puppet_lint.md#readme)                               | :heavy_check_mark: |                        [![GitHub last commit](https://img.shields.io/github/last-commit/rodjek/puppet-lint)](https://github.com/rodjek/puppet-lint/commits)                        |
|   <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/snakemake.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon -->    | [**SNAKEMAKE**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/snakemake.md#readme)           | [snakemake](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/snakemake_snakemake.md#readme)                          | [SNAKEMAKE_LINT](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/snakemake_snakemake.md#readme)                                  |                    |                       [![GitHub last commit](https://img.shields.io/github/last-commit/snakemake/snakemake)](https://github.com/snakemake/snakemake/commits)                       |
|                                                                      <!-- --> <!-- linter-icon -->                                                                       |                                                                                                                    | [snakefmt](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/snakemake_snakefmt.md#readme)                            | [SNAKEMAKE_SNAKEFMT](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/snakemake_snakefmt.md#readme)                               | :heavy_check_mark: |                        [![GitHub last commit](https://img.shields.io/github/last-commit/snakemake/snakefmt)](https://github.com/snakemake/snakefmt/commits)                        |
|     <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/tekton.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon -->     | [**TEKTON**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/tekton.md#readme)                 | [tekton-lint](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/tekton_tekton_lint.md#readme)                         | [TEKTON_TEKTON_LINT](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/tekton_tekton_lint.md#readme)                               |                    |                           [![GitHub last commit](https://img.shields.io/github/last-commit/IBM/tekton-lint)](https://github.com/IBM/tekton-lint/commits)                           |
|   <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/terraform.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon -->    | [**TERRAFORM**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/terraform.md#readme)           | [tflint](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/terraform_tflint.md#readme)                                | [TERRAFORM_TFLINT](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/terraform_tflint.md#readme)                                   |                    |                  [![GitHub last commit](https://img.shields.io/github/last-commit/terraform-linters/tflint)](https://github.com/terraform-linters/tflint/commits)                  |
|                                                                      <!-- --> <!-- linter-icon -->                                                                       |                                                                                                                    | [terrascan](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/terraform_terrascan.md#readme)                          | [TERRAFORM_TERRASCAN](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/terraform_terrascan.md#readme)                             |                    |                        [![GitHub last commit](https://img.shields.io/github/last-commit/accurics/terrascan)](https://github.com/accurics/terrascan/commits)                        |
|                                                                      <!-- --> <!-- linter-icon -->                                                                       |                                                                                                                    | [terragrunt](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/terraform_terragrunt.md#readme)                        | [TERRAFORM_TERRAGRUNT](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/terraform_terragrunt.md#readme)                           | :heavy_check_mark: |                   [![GitHub last commit](https://img.shields.io/github/last-commit/gruntwork-io/terragrunt)](https://github.com/gruntwork-io/terragrunt/commits)                   |
|                                                                      <!-- --> <!-- linter-icon -->                                                                       |                                                                                                                    | [terraform-fmt](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/terraform_terraform_fmt.md#readme)                  | [TERRAFORM_TERRAFORM_FMT](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/terraform_terraform_fmt.md#readme)                     | :heavy_check_mark: |                       [![GitHub last commit](https://img.shields.io/github/last-commit/hashicorp/terraform)](https://github.com/hashicorp/terraform/commits)                       |
|                                                                      <!-- --> <!-- linter-icon -->                                                                       |                                                                                                                    | [checkov](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/terraform_checkov.md#readme)                              | [TERRAFORM_CHECKOV](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/terraform_checkov.md#readme)                                 |                    |                      [![GitHub last commit](https://img.shields.io/github/last-commit/bridgecrewio/checkov)](https://github.com/bridgecrewio/checkov/commits)                      |
|                                                                      <!-- --> <!-- linter-icon -->                                                                       |                                                                                                                    | [kics](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/terraform_kics.md#readme)                                    | [TERRAFORM_KICS](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/terraform_kics.md#readme)                                       |                    |                            [![GitHub last commit](https://img.shields.io/github/last-commit/checkmarx/kics)](https://github.com/checkmarx/kics/commits)                            |

### Other

|                                                                              <!-- -->                                                                               | Code quality checker                                                                                         | Linter                                                                                                             | Configuration key                                                                                                              |     Format/Fix     |                                                                       Status                                                                       |
|:-------------------------------------------------------------------------------------------------------------------------------------------------------------------:|--------------------------------------------------------------------------------------------------------------|--------------------------------------------------------------------------------------------------------------------|--------------------------------------------------------------------------------------------------------------------------------|:------------------:|:--------------------------------------------------------------------------------------------------------------------------------------------------:|
| <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/copypaste.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon --> | [**COPYPASTE**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/copypaste.md#readme)     | [jscpd](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/copypaste_jscpd.md#readme)             | [COPYPASTE_JSCPD](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/copypaste_jscpd.md#readme)               |                    |          [![GitHub last commit](https://img.shields.io/github/last-commit/kucherenko/jscpd)](https://github.com/kucherenko/jscpd/commits)          |
|  <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/default.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon -->  | [**CREDENTIALS**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/credentials.md#readme) | [secretlint](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/credentials_secretlint.md#readme) | [CREDENTIALS_SECRETLINT](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/credentials_secretlint.md#readme) |                    |     [![GitHub last commit](https://img.shields.io/github/last-commit/secretlint/secretlint)](https://github.com/secretlint/secretlint/commits)     |
|    <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/git.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon -->    | [**GIT**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/git.md#readme)                 | [git_diff](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/git_git_diff.md#readme)             | [GIT_GIT_DIFF](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/git_git_diff.md#readme)                     |                    |                   [![GitHub last commit](https://img.shields.io/github/last-commit/git/git)](https://github.com/git/git/commits)                   |
|   <img src="https://github.com/megalinter/megalinter/raw/main/docs/assets/icons/spell.ico" alt="" height="32px" class="megalinter-icon"></a> <!-- linter-icon -->   | [**SPELL**](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/spell.md#readme)             | [misspell](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/spell_misspell.md#readme)           | [SPELL_MISSPELL](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/spell_misspell.md#readme)                 | :heavy_check_mark: |          [![GitHub last commit](https://img.shields.io/github/last-commit/client9/misspell)](https://github.com/client9/misspell/commits)          |
|                                                                    <!-- --> <!-- linter-icon -->                                                                    |                                                                                                              | [cspell](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/spell_cspell.md#readme)               | [SPELL_CSPELL](https://github.com/megalinter/megalinter/tree/main/docs/descriptors/spell_cspell.md#readme)                     |                    | [![GitHub last commit](https://img.shields.io/github/last-commit/streetsidesoftware/cspell)](https://github.com/streetsidesoftware/cspell/commits) |

<!-- linters-table-end -->

<!-- linters-section-end -->
